local final = {}

final.create = function(player)
  local frame = player.gui.center.add({
    type = 'frame',
    direction = 'vertical',
    name = 'final',
    caption = { 'final-screen.heading' }
  })
  frame.style.width = 420
  
  local scroller = frame.add({
    type = 'scroll-pane',
    name = 'scrolling-text',
    direction = "vertical"
  })
  
  if game.is_demo() then
    for h=1,3 do
      local text = scroller.add({
        type='label',
        caption = {"",{"final-screen.text-demo-"..h},"\n"},
      })
      text.style.single_line = false
      text.style.width = 380
    end
    
    local list_table = scroller.add({
      type = 'table',
      column_count = 3
    })
    
    local items = {
      {{'final-screen.item-1'},'item','locomotive'},
      {{'final-screen.item-5'},'item','construction-robot'},
      {{'final-screen.item-2'},'item','tank'},
      {{'final-screen.item-6'},'item','nuclear-reactor'},
      {{'final-screen.item-4'},'item','power-armor'},
      {{'final-screen.item-8'},'item','laser-turret'},
      {{'final-screen.item-7'},'item','solar-panel'},
      {{'final-screen.item-9'},'item','energy-shield-equipment'},
      {{'final-screen.item-3'},'item','rocket'},
      {{'final-screen.item-10'},'fluid','petroleum-gas'},
      {{'final-screen.item-11'},'item','blueprint'},
      {{'final-screen.item-12'},'item','decider-combinator'},
    }
    
    for _, item in pairs(items) do
  
      local text = list_table.add({
        type='label',
        caption = {"","[font=default-semibold]",item[1],"[/font]"},
      })
      text.style.single_line = true
      text.style.width = 125
    end
  
    local text = scroller.add({
          type='label',
          caption = {"",{"final-screen.and-much-more"}},
        })
    text.style.single_line = false
    text.style.width = 380
    
  else
    for h=1,3 do
      local text = scroller.add({
        type='label',
        caption = {"",{"final-screen.text-"..h},"\n"},
      })
      text.style.single_line = false
      text.style.width = 380
    end
  end
  

  
  local text = scroller.add({
        type='label',
        caption = {"","\n",{"final-screen.thanks"},"\n"},
      })
  text.style.single_line = false
  text.style.width = 380
  
  
  local button_flow = frame.add{type = "flow"}
  button_flow.style.horizontally_stretchable = true
  button_flow.style.vertical_align = "center"
  button_flow.style.top_padding = 4
  
  --add button 1 here
  button_flow.add({
    type = 'button',
    name = 'end_button',
    style = 'red_back_button',
    caption = {"final-screen.end"}
  })
  
  local pusher = button_flow.add{type = "empty-widget", style = "draggable_space_header"}
  pusher.style.vertically_stretchable = true
  pusher.style.horizontally_stretchable = true
  --pusher.drag_target = frame
  
  --add button 2 here
  button_flow.add({
    type = 'button',
    name = 'continue_button',
    style = 'confirm_button',
    caption = {"final-screen.continue"}
  })
  
end

final.on_click = function(event)
  if event.element and event.element.valid and (event.element.name == 'end_button' or event.element.name == 'continue_button') then
    local button_name = event.element.name
    event.element.parent.parent.destroy()
    game.tick_paused = false
    return true, button_name
  end
  return false
end

return final
